//+------------------------------------------------------------------+
//|                                            FRASMA-SSA_ALert.mq4  |
//|    (Formerly known as 3MACross_AlertWarnSig 2008forextsd mladen) |
//|     Mod by CamaRon to use SSA and Frasma                         |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
//----
#property indicator_chart_window
#property indicator_buffers 2
//----
#property indicator_color1 Aqua
#property indicator_color2 Gold

//----
extern int Lag=30;
extern int Comp=5;
extern int SSABars=200;
extern int Frasma_eperiod=100;
extern int Frasma_nspeed=20;
extern int Frasma_shift=0;




extern bool crossesOnCurrent=false;
extern bool alertsOn        =true;
extern bool alertsMessage   =true;
extern bool alertsSound     =false;
extern bool alertsEmail     =false;

//----
double CrossUp[];
double CrossDown[];
double CrossWUp[];
double CrossWDown[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0, CrossUp);    SetIndexStyle(0, DRAW_ARROW,0,10); SetIndexArrow(0, 177);
   SetIndexBuffer(1, CrossDown);  SetIndexStyle(1, DRAW_ARROW,0,10); SetIndexArrow(1, 177);
   
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    limit, i;
   int    counted_bars=IndicatorCounted();
   double SSAnow, SSAprevious;
   double FRASMAnow, FRASMAprevious;
   
//----
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----
   for(i=limit; i >=0; i--)
     {
      double Range=0.0;
      for(int counter=i ;counter<=i+9;counter++) Range+=MathAbs(High[counter]-Low[counter]);
      Range/=10;
//----
      SSAnow     =iCustom(NULL,0,"SSA of price",Lag,Comp,SSABars,0,i);
      SSAprevious=iCustom(NULL,0,"SSA of price",Lag,Comp,SSABars,0,i+1);
      FRASMAnow     =iCustom(NULL,0,"FRASMA_v2",Frasma_eperiod,Frasma_nspeed,Frasma_shift,0,i);
      FRASMAprevious=iCustom(NULL,0,"FRASMA_v2",Frasma_eperiod,Frasma_nspeed,Frasma_shift,0,i+1);
      
      
      //avoid current bar if not allowed to check crosses on current (i==0)
      if (crossesOnCurrent==false && i==0) continue;
//----
      int    crossID=0;
      double curr;
      double prev;
      double point;
      while(true)
        {
         curr=SSAnow      - FRASMAnow;
         prev=SSAprevious - FRASMAprevious;
         point=(SSAnow      + SSAprevious)/2;
         if (curr*prev<=0) { crossID=1; break; }
         point=(FRASMAnow      + FRASMAprevious)/2;
         if (curr*prev<=0) { crossID=2; break; }
         break;
        }
      //    the interesting thing is the direction of the crossing
      //    which MA is the primary and which one the secondary
      //    if you do not know that you can not determine the "direction"
      //    of the cross
      CrossUp[i]   =EMPTY_VALUE;
      CrossDown[i] =EMPTY_VALUE;
      CrossWUp[i]  =EMPTY_VALUE;
      CrossWDown[i]=EMPTY_VALUE;
      if (crossID>0)
        {
         if (alertsOn)
            if ((i==0 && crossesOnCurrent==true) || (i==1 && crossesOnCurrent==false))
              {
               switch(crossID)
                 {
                  case 1:
                     if(curr>0) doAlert(" FractalAlert: Possibly Going UP");
                     else       doAlert(" FractalAlert: Possibly Going DOWN");
                     break;
                  
                 }
              }
         //----
         if (i==0)
           {
            if (curr>0)
               CrossWUp[i]  =point - Range*1.2;
            else  CrossWDown[i]=point + Range*1.2;
           }
         else
           {
            if (curr>0)
               CrossUp[i]  =point - Range*1.2;
            else  CrossDown[i]=point + Range*1.2;
           }
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void doAlert(string doWhat)
  {
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
//----
     if (previousAlert!=doWhat || previousTime!=Time[0]) 
     {
      previousAlert =doWhat;
      previousTime  =Time[0];
      //        if time needed :
      //        message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," @",Bid," ", doWhat);
      message= StringConcatenate(Symbol()," at ",Bid," ", doWhat);
      if (alertsMessage) Alert(message);
      if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SSA/FRASMACross:"," M",Period()),message);
      if (alertsSound)   PlaySound("alert2.wav");
     }
  }
//+------------------------------------------------------------------+